stm8/

	TITLE first_block.asm”
	MOTOROLA

	#include "STM8S103F3P.inc"

	BYTES
	segment byte at 0000 'first_block'
boot_RAM_start:
; Включаем pull-up на портах (если подтяжка не предусмотрена внешней схемой) или не включаем, все равно работает, экономим 14 байт
;  ld    A, #%01001100              ; [A6 4C]
;  cpl    A                         ; [43]
;  ld    PA_CR1, A                  ; [C7 50 03]
;  ld    PB_CR1, A                  ; [C7 50 08]
;  ld    PC_CR1, A                  ; [C7 50 0D]
;  ld    PD_CR1, A                  ; [C7 50 12] подтяжка на PD6(UART1_RX), PD2, PD1
; настраиваем UART1 на прием/передачу на скорости 9600, остальные настройки по умолчанию (8 бит, нет бита четности, 1 стоповый бит)
  mov    UART1_BRR2, #0            ; [35 00 52 33]  для Fmaster=16/8=2МГц и 9600
;   mov    UART1_BRR1, #13           ; [35 0D 52 32]  для Fmaster=16/8=2МГц и 9600
   mov    UART1_BRR1, #1           ; [35 0D 52 32]  для Fmaster=16/8=2МГц и 128000
   mov    UART1_CR2, #%00001100     ; [35 0C 52 35]    UART1_CR2.TEN <- 1  UART1_CR2.REN <- 1  разрешаем передачу/прием
   
boot_RAM_main_cycle:
	
boot_RAM_wait_byte1:
    btjf  UART1_SR, #5, boot_RAM_wait_byte1
    ld     A, UART1_DR
    ld     XH, A
boot_RAM_wait_byte2:
    btjf  UART1_SR, #5, boot_RAM_wait_byte2
    ld     A, UART1_DR
    ld     XL, A
  
; включаем светодиод	
    bset 	PB_DDR,#5 		;
    bset 	PB_CR1,#5 		; 

	ldw		Y, #64
boot_RAM_read_cycle:
	ld		A, (X)
    ld     UART1_DR, A
boot_RAM_wait_tx:
	btjf	UART1_SR, #7, boot_RAM_wait_tx	; skip if UART1_SR.TXE = 0		TXE: Transmit data register empty
	incw	X
	decw	Y
	jrne	boot_RAM_read_cycle
	
; выключаем светодиод	
    bres 	PB_DDR,#5 		;
    bres 	PB_CR1,#5 		; 

	
    jra     boot_RAM_main_cycle
   

	end
